package org.jboss.jtademo;

import javax.transaction.*;
import javax.transaction.xa.*;

import org.postgresql.xa.*;

import javax.sql.*;
import java.sql.*;

import java.util.*;

public class AS {

	
	private Map<String, XAConnection> connectionMap = new HashMap<String, XAConnection>();	

	public AS() {}
	
	public Connection getConnection() throws Exception 
	{
		PGXADataSource ds = new PGXADataSource();
		ds.setServerName("localhost");
		ds.setPortNumber(5432);
		ds.setDatabaseName("jtaex");
		ds.setUser("jtaex");
		ds.setPassword("jtaex");
		XAConnection conn = ds.getXAConnection();
		getTM().getTransaction().enlistResource(conn.getXAResource());
		conn.getConnection().setAutoCommit(false);
		connectionMap.put(conn.getConnection().toString(), conn);
		return conn.getConnection();
	}

	public void close(Connection dbConn) throws Exception 
	{
		XAConnection conn = connectionMap.get(dbConn.toString());
		getTM().getTransaction().delistResource(conn.getXAResource(), XAResource.TMSUCCESS);
		connectionMap.remove(dbConn);
	}

	public TransactionManager getTM() throws Exception 
	{
		return com.arjuna.ats.jta.TransactionManager.transactionManager();
	}
	
	public UserTransaction getUT() throws Exception 
	{
		return com.arjuna.ats.jta.UserTransaction.userTransaction();
	}
}
