package org.jboss.jtademo;

import javax.transaction.Status;
import javax.transaction.xa.XAResource;

public class Util
{

   public static String convertTMFlags(int tmflag)
   {
      StringBuilder res = new StringBuilder().append(tmflag).append(" - ");
      
      switch (tmflag)
      {
         case XAResource.TMFAIL:
            res.append("TMFAIL");
            break;
         case XAResource.TMJOIN:
            res.append("TMJOIN");
            break;
         case XAResource.TMRESUME:
            res.append("TMRESUME");
            break;
         case XAResource.TMSUCCESS:
            res.append("TMSUCCESS");
            break;
         case XAResource.TMSUSPEND:
            res.append("TMSUSPEND");
            break;
         case XAResource.TMENDRSCAN:
            res.append("TMENDRSCAN");
            break;
         case XAResource.TMNOFLAGS:
            res.append("TMNOFLAGS");
            break;
         case XAResource.TMONEPHASE:
            res.append("TMONEPHASE");
            break;
         case XAResource.TMSTARTRSCAN:
            res.append("TMSTARTRSCAN");
            break;
         default:
            res.append("unknown");
      }
      
      return res.toString();
   }
   
      
   public static String convertTransactionStatus(int status)
   {
      StringBuilder res = new StringBuilder().append(status).append(" - ");

      switch (status)
      {
         case Status.STATUS_ACTIVE:
            res.append("ACTIVE");
            break;
         case Status.STATUS_COMMITTED:
            res.append("COMMITTED");
            break;
         case Status.STATUS_COMMITTING:
            res.append("COMMITTING");
            break;
         case Status.STATUS_MARKED_ROLLBACK:
            res.append("MARKED_ROLLBACK");
            break;
         case Status.STATUS_NO_TRANSACTION:
            res.append("NO_TRANSACTION");
            break;
         case Status.STATUS_PREPARED:
            res.append("PREPARED");
            break;
         case Status.STATUS_PREPARING:
            res.append("PREPARING");
            break;
         case Status.STATUS_ROLLEDBACK:
            res.append("ROLLEDBACK");
            break;
         case Status.STATUS_ROLLING_BACK:
            res.append("ROLLING_BACK");
            break;
         default:    // Status.STATUS_UNKNOWN:
            res.append("UNKNOWN");
      }
      
      return res.toString();
   }
   
}
